<!--
 ~ Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 ~
 ~ WSO2 Inc. licenses this file to you under the Apache License,
 ~ Version 2.0 (the "License"); you may not use this file except
 ~ in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~    http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing,
 ~ software distributed under the License is distributed on an
 ~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 ~ KIND, either express or implied.  See the License for the
 ~ specific language governing permissions and limitations
 ~ under the License.
 -->
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@ page import="org.wso2.carbon.governance.services.ui.utils.AddServiceUIGenerator" %>
<%@ page import="org.apache.axiom.om.OMElement" %>
<%@ page import="org.wso2.carbon.governance.services.ui.utils.UIGeneratorConstants" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="javax.xml.namespace.QName" %>
<%@ page import="org.wso2.carbon.governance.services.ui.clients.AddServicesServiceClient" %>
<%@ page import="org.wso2.carbon.registry.extensions.utils.CommonConstants" %>

<script type="text/javascript" src="../yui/build/utilities/utilities.js"></script>
<jsp:include page="../registry_common/registry_common-i18n-ajaxprocessor.jsp"/>
<script type="text/javascript" src="../registry_common/js/registry_validation.js"></script>
<script type="text/javascript" src="../registry_common/js/registry_common.js"></script>
<script type="text/javascript" src="../ajax/js/prototype.js"></script>
<%
    AddServiceUIGenerator uigen = new AddServiceUIGenerator();
    AddServicesServiceClient client = new AddServicesServiceClient(config,session);
    OMElement head = uigen.getUIConfiguration(client.getServiceConfiguration(),request,config,session);
    Iterator widgets = head.getChildrenWithName(new QName(null,UIGeneratorConstants.WIDGET_ELEMENT));
    StringBuilder table = new StringBuilder();
    while (widgets.hasNext()) {
        OMElement widget = (OMElement) widgets.next();
        table.append(uigen.printWidgetWithValues(widget, null, false, request));
    }
    String[] mandatory = uigen.getMandatoryIdList(head);
    String[] name = uigen.getMandatoryNameList(head);
    String[] addName = uigen.getUnboundedNameList(head);
    String[] addWidget = uigen.getUnboundedWidgetList(head);
    String[][] selectValueList = uigen.getUnboundedValues(head);
//    String configuration;
//    try {
//        configuration = AddServicesUtil.getServiceConfiguration(session,config);
//    } catch (Exception e) {
//        configuration = null;
//    }
//    if(configuration == null){
//        request.setAttribute(CarbonUIMessage.ID,new CarbonUIMessage(error,error,null));
%>
<%--<jsp:include page="../admin/error.jsp?<%=error%>"/>--%>
<%
    //        return;
//    }
//    String[] splittedconfig = configuration.split(":");
//    String[] endpoints = RegistryConstants.GOVERNANCE_ENDPOINTS.split(",");
%>
<fmt:bundle basename="org.wso2.carbon.governance.services.ui.i18n.Resources">
<carbon:breadcrumb
            label="services.menu.text"
            resourceBundle="org.wso2.carbon.governance.services.ui.i18n.Resources"
            topPage="true"
            request="<%=request%>" />
<carbon:jsi18n
        resourceBundle="org.wso2.carbon.governance.services.ui.i18n.JSResources"
        request="<%=request%>" namespace="org.wso2.carbon.governance.services.ui"/>
    <br/>

    <script type="text/javascript">
        <% if (request.getParameter("wsdlError") != null) { %>
            CARBON.showErrorDialog("<%=request.getParameter("wsdlError")%>");
        <% } %>
        function addEditService(){
        sessionAwareFunction(function() {
            var versionString = (document.getElementById('id_Overview_Version')).value;
            if(versionString.length > 0){
//                var regexp = new RegExp("^[1-9]\\d*[.]\\d+[.]\\d+$","i");
                var regexp = new RegExp("<%=CommonConstants.SERVICE_VERSION_REGEX.replace("\\","\\\\") %>","i");
                if(!versionString.match(regexp)){
                    CARBON.showWarningDialog(org_wso2_carbon_governance_services_ui_jsi18n["version.error.1"]
                            +" "+ versionString +" " +org_wso2_carbon_governance_services_ui_jsi18n["version.error.2"]);
                    return;
                }
            }
                getServiceName();
                var reason = "";
            <%for(int i=0;i<mandatory.length;i++){%>
                reason += validateEmpty(document.getElementById('<%=mandatory[i]%>'),
                        "<%=name[i]%>");
            <%}%>
                var CustomUIForm=document.getElementById('CustomUIForm');
                var waitMessage = document.getElementById('waitMessage');
                var buttonRow = document.getElementById('buttonRow');
                var serviceName = document.getElementById('id_Overview_Name');
                var namespaceValue = document.getElementById('id_Overview_Namespace');
                reason += validateIllegal(serviceName);
                reason += validateIllegal(namespaceValue);
                if(reason!=""){
                    CARBON.showWarningDialog(reason);
                    return;
                }else{
                    buttonRow.style.display = "none";
                    waitMessage.style.display = "";
                    CustomUIForm.submit();
                }
            }, org_wso2_carbon_governance_services_ui_jsi18n["session.timed.out"]);
        }

        function getServiceName(){
            var serviceLoader= document.getElementById('serviceLoader');

            serviceLoader.innerHTML='<img src="images/ajax-loader.gif" align="left" hspace="20"/><fmt:message key="please.wait.saving.details.for"/> '+document.getElementById('id_Overview_Name').value+'...';
        }

        function clearAll() {
            var table = $('#_addTable');
            var Inputrows = table.getElementsByTagName('input');

            for (var i = 0; i < Inputrows.length; i++) {
                if (Inputrows[i].type == "text") {
                    Inputrows[i].value = "";
                } else if (Inputrows[i].type == "checkbox") {
                    Inputrows[i].checked = false;
                }
            }

            var TextAreas = table.getElementsByTagName('textarea');
            for (var i = 0; i < TextAreas.length; i++) {
                TextAreas[i].value = "";
            }
            var SelectAreas = table.getElementsByTagName('select');
            for (var i = 0; i < SelectAreas.length; i++) {
                SelectAreas[i].selectedIndex = 0;
            }
        }


       <%
        if (addName != null && addWidget != null && selectValueList != null) {
            for (int i = 0; i < addName.length; i++) {
       %>
        <%=addName[i]%>Count = 0;
        jQuery(document).ready(function() {
            for (var i = 0; i < 0; i++) {
                add<%=addName[i]%>_<%=addWidget[i]%>();
            }
        });

        function add<%=addName[i]%>_<%=addWidget[i]%>() {
        <%String[] valuelist = selectValueList[i];%>
            var epOptions = '<%for(int j=0;j<valuelist.length;j++){%><option value="<%=valuelist[j]%>"><%=valuelist[j]%></option><%}%>';
            var endpointMgt = document.getElementById('<%=addName[i]%>Mgt');
            endpointMgt.parentNode.style.display = "";
            if (<%=addName[i]%>Count > 0) {
                for (var i = 1; i <= <%=addName[i]%>Count; i++) {
                    var endpoint = document.getElementById(i);
                    if (endpoint.value == "") {
                        return;
                    }
                }
            }
            <%=addName[i]%>Count++;
            var epCountTaker = document.getElementById('<%=addName[i]%>CountTaker');
            epCountTaker.value = <%=addName[i]%>Count;
            var theTr = document.createElement("TR");
            var theTd1 = document.createElement("TD");
            var theTd2 = document.createElement("TD");
            var td1Inner = '<select name="<%=(addWidget[i].replaceAll(" ","_") + "_" + addName[i].replaceAll(" ","-"))%>' + <%=addName[i]%>Count + '">' + epOptions + '</select>';
            var td2Inner = '<input id="' + <%=addName[i]%>Count + '" type="text" name="<%=addWidget[i].replaceAll(" ","_") + UIGeneratorConstants.TEXT_FIELD + "_" + addName[i].replaceAll(" ","-")%>' + <%=addName[i]%>Count + '" style="width:400px"/>';

            theTd1.innerHTML = td1Inner;
            theTd2.innerHTML = td2Inner;

            theTr.appendChild(theTd1);
            theTr.appendChild(theTd2);

            endpointMgt.appendChild(theTr);


        }
        <%
              }

        }
        %>

    </script>
    <%
        if(table != null){
    %>

    <div id="middle">

        <h2><fmt:message key="add.service"/></h2>

        <div id="workArea">

            <div id="activityReason" style="display: none;"></div>
            <form id="CustomUIForm" action="../services/add_service_ajaxprocessor.jsp" method="post">
                <input type="hidden" name="operation" value="Add"/>
                <input type="hidden" name="currentname" value="">
                <input type="hidden" name="currentnamespace" value="">
                <table class="styledLeft" id="#_addTable">
                    <tr><td>
                        <%=table.toString()%>
                    </td></tr>
                    <tr id="buttonRow">
                        <td class="buttonRow">
                            <input class="button registryWriteOperation" type="button"
                                   value="<fmt:message key="save"/>" onclick="addEditService()" />
                            <input class="button registryNonWriteOperation" type="button"
                                   value="<fmt:message key="save"/>" disabled="disabled" />
                            <input type="button" id="#_1" value="<fmt:message key="clear"/>" class="button"
                   onclick="clearAll()"/>
                        </td>
                    </tr>
                    <tr id="waitMessage" style="display:none">
                        <td>
                            <div style="font-size:13px !important;margin-top:10px;margin-bottom:10px;margin-left:5px !important" id="serviceLoader" class="ajax-loading-message">
                            </div>
                        </td>
                    </tr>

                </table>
            </form>
            <br/>

            <div id="AddService">
            </div>
        </div>
    </div>
    <%}%>
</fmt:bundle>
